# env.py
# -*- coding: utf-8 -*-
# Global environment structures. Basically, everything 
# that needs to be saved should be put here

# Put your things in here. This is because it's much harder to restore an entire module's namespace
# (without hacking its namespace dictionary, that is).
from collections import defaultdict

import areas

def default(): # Small hack because you can't pickle anonymous functions
    return False

orig_env = { "wazzamo" : False, 
             "current_area" : areas.areas["your_cottage"], 
             "inventory" : {},
             "areas" : {},
             "accomplishments" : defaultdict(default), # Some flags that affect all areas. Default is false.
             "nowplaying" : "", # We need to restore this after loading a game
             }

env = {}

for key,value in orig_env.iteritems():
    if isinstance(value, dict):
        env[key] = value.copy()
    else:
        env[key] = value

def save_current_area_state():
    """Since the state is altered for the current_state instance of an area, but not
    for the areas we save "behind us", we need to make sure they are the same when 
    switching to another area. Use this function for that."""

    current_id = env["current_area"].name
    env["areas"][current_id] = env["current_area"] 
