#Parser.py
# -*- coding: utf-8 -*-

import commands
import utils
import sys

command_aliases = { "go north" : (lambda x: commands.go("north")), # Directions
                    "go n" : (lambda x: commands.go("north")),
                    "g n" : (lambda x: commands.go("north")),
                    "g north" : (lambda x: commands.go("north")),
                    "north" : (lambda x: commands.go("north")),
                    "n" : (lambda x: commands.go("north")),
                    
                    "go south" : (lambda x: commands.go("south")),
                    "go s" : (lambda x: commands.go("south")),
                    "g s" : (lambda x: commands.go("south")),
                    "g south" : (lambda x: commands.go("south")),
                    "south" : (lambda x: commands.go("south")),
                    "s" : (lambda x: commands.go("south")),

                    "go west" : (lambda x: commands.go("west")),
                    "go w" : (lambda x: commands.go("west")),
                    "g w" : (lambda x: commands.go("west")),
                    "g west" : (lambda x: commands.go("west")),
                    "west" : (lambda x: commands.go("west")),
                    "w" : (lambda x: commands.go("west")),
                    
                    "go east" : (lambda x: commands.go("east")),
                    "go e" : (lambda x: commands.go("east")),
                    "g e" : (lambda x: commands.go("east")),
                    "g east" : (lambda x: commands.go("east")),
                    "east" : (lambda x: commands.go("east")),
                    "e" : (lambda x: commands.go("east")),
                    
                    "go northwest" : (lambda x: commands.go("northwest")),
                    "go nw" : (lambda x: commands.go("northwest")),
                    "g nw" : (lambda x: commands.go("northwest")),
                    "g northwest" : (lambda x: commands.go("northwest")),
                    "northwest" : (lambda x: commands.go("northwest")),
                    "nw" : (lambda x: commands.go("northwest")),
                    
                    "go northeast" : (lambda x: commands.go("northeast")),
                    "go ne" : (lambda x: commands.go("northeast")),
                    "g ne" : (lambda x: commands.go("northeast")),
                    "g northeast" : (lambda x: commands.go("northeast")),
                    "northeast" : (lambda x: commands.go("northeast")),
                    "ne" : (lambda x: commands.go("northeast")),
                    
                    "go southwest" : (lambda x: commands.go("southwest")),
                    "go sw" : (lambda x: commands.go("southwest")),
                    "g sw" : (lambda x: commands.go("southwest")),
                    "g southwest" : (lambda x: commands.go("southwest")),
                    "southwest" : (lambda x: commands.go("southwest")),
                    "sw" : (lambda x: commands.go("southwest")),
                    
                    "go southeast" : (lambda x: commands.go("southeast")),
                    "go se" : (lambda x: commands.go("southeast")),
                    "g se" : (lambda x: commands.go("southeast")),
                    "g southeast" : (lambda x: commands.go("southeast")),
                    "southeast" : (lambda x: commands.go("southeast")),
                    "se" : (lambda x: commands.go("southeast")),
                    
                    "go up" : (lambda x: commands.go("up")),
                    "go u" : (lambda x: commands.go("up")),
                    "g u" : (lambda x: commands.go("up")),
                    "g up" : (lambda x: commands.go("up")),
                    "up" : (lambda x: commands.go("up")),
                    "u" : (lambda x: commands.go("up")),
                    "climb" : (lambda x: commands.go("up")),
                    "climb u" : (lambda x: commands.go("up")),
                    "climb up" : (lambda x: commands.go("up")),
                    
                    "go down" : (lambda x: commands.go("down")),
                    "go d" : (lambda x: commands.go("down")),
                    "g d" : (lambda x: commands.go("down")),
                    "g down" : (lambda x: commands.go("down")),
                    "down" : (lambda x: commands.go("down")),
                    "d" : (lambda x: commands.go("down")),
                    "climb down" : (lambda x: commands.go("down")),
                    "climb d" : (lambda x: commands.go("down")),
                    
                    "go" : lambda x: utils.add_message("Go where?"),

                    # Normal commands.
                    "take" : commands.take,
                    "t" : commands.take,
                    "pick up" : commands.take,

                    "drop" : commands.drop,
                    "relinquish" : commands.drop,
                    "throw" : commands.drop,
                    "throw away" : commands.drop,
                    
                    "inventory" : commands.inventory,
                    "items" : commands.inventory,
                    "i" : commands.inventory,

                    "put" : commands.put,
                    "place" : commands.put,
                    "insert" : commands.put,
                    
                    "look" : commands.examine,
                    "look at" : commands.examine,
                    "examine" : commands.examine,
                    "l" : commands.examine,

                    "use" : commands.use,

                    "save" : commands.save,
                    "load" : commands.load,
                    "restore" : commands.load,

                    "quit": lambda x: sys.exit(0),

                    "help" : commands.help,
                    "h" : commands.help,
                    "?" : commands.help,

                    "die" : (lambda x: commands.warp(["dead"])), # Args is a list
                    
                    "mute" : commands.mute, 
                    "fullscreen" : commands.fullscreen, 
                    
                    # Commands that require specific items are specified on a per area basis, unless it's used very much
                    
                    # wazzamo 
                    "i put on my robe and wizard hat" : (lambda x: commands.wazzamo(True)),
                    "burn the heretic" : (lambda x: commands.wazzamo(False)),
                    
                    "warp" : commands.warp,
                    "spawn" : commands.spawn_item,
                    "getenv" : commands.getenv,
                    "setenv" : commands.setenv,

                    99.15 : (lambda name, args: commands.local_function(name, args)), # Arbitrary number. Identifier cannot be a string
                    }

class Parser:
    def __init__(self, command_env):
        self.commands = command_env
        
    def try_input(self, s, args):
        if not commands.local_function(s, args):            
            if self.commands.has_key(s):
                fun = self.commands[s]
                fun(args)
                return True
            else:
                #return self.commands[99.15](s, args)
                return False
        else:
            return True
    
    def parse(self,  s):
        """self.commands -- dictionary of command name: function pairs. Multiple commands may have the same function.
        All functions should accept a list of strings, which is the formal parameters."""
        s = s.lower()
        words = s.split(" ")
    
        found = False
        for i in xrange(len(words), 0, -1):
            found = self.try_input(" ".join(words[:i]), words[i:]) #cadaddadrdrdadr
            if found:
                break
        if not found:
            utils.add_message("You can't do that.")
