# render_image.py
# -*- coding: utf-8 -*-

import data
import objects

image_cache = {} # These are images necessary to render other images

def get_image(filename, colorkey=None):
    #if not filename in image_cache:
    image = data.load_image(filename, colorkey)
    image_cache[filename] = image
    return image
    #else:
    #    return image_cache[filename]

def area_image(background_name, objs):
    """Place objects on background.

    background_name -- filename of the background. This is cached, so do not worry about performance.
    objects -- list of rect, object_id pairs. The rect defines where to put the image."""

    bg_image = get_image(background_name)
    
    ret_image = bg_image.copy()

    for obj_id, rect in objs:
        o_filename = objects.filenames[obj_id]
        o_image = get_image(o_filename, colorkey=-1)
        ret_image.blit(o_image, rect)

    return ret_image
